<!--⚠️ Note that this file is in Markdown but contain specific syntax for our doc-builder (similar to MDX) that may not be
rendered properly in your Markdown viewer.
-->

# जल्दी शुरू

[Hugging Face Hub](https://huggingface.co/) मशीन लर्निंग साझा करने के लिए उपयुक्त जगह है
मॉडल, डेमो, डेटासेट और मेट्रिक्स। `huggingface_hub` लाइब्रेरी आपको बातचीत करने में मदद करती है
अपने विकास परिवेश को छोड़े बिना हब। आप बना और प्रबंधित कर सकते हैं
रिपॉजिटरी आसानी से, फ़ाइलें डाउनलोड और अपलोड करें, और उपयोगी मॉडल और डेटासेट प्राप्त करें
हब से मेटाडेटा.

## इंस्टालेशन

आरंभ करने के लिए, `huggingface_hub` लाइब्रेरी स्थापित करें:

```bash
pip install --upgrade huggingface_hub
```

अधिक विवरण के लिए, [installation](इंस्टॉलेशन) गाइड देखें।

## फ़ाइलें डाउनलोड करें

हब पर रिपोजिटरीज़ गिट संस्करण नियंत्रित हैं, और उपयोगकर्ता एक फ़ाइल डाउनलोड कर सकते हैं
या संपूर्ण भंडार. आप फ़ाइलें डाउनलोड करने के लिए [`hf_hub_download`] फ़ंक्शन का उपयोग कर सकते हैं।
यह फ़ंक्शन आपकी स्थानीय डिस्क पर एक फ़ाइल को डाउनलोड और कैश करेगा। अगली बार जब तुम्हें जरूरत पड़े
वह फ़ाइल, यह आपके कैश से लोड होगी, इसलिए आपको इसे दोबारा डाउनलोड करने की आवश्यकता नहीं है।

आपको उस फ़ाइल की रिपोजिटरी आईडी और फ़ाइल नाम की आवश्यकता होगी जिसे आप डाउनलोड करना चाहते हैं। के लिए
उदाहरण के लिए, [Pegasus](https://huggingface.co/google/pegasus-xsum) मॉडल डाउनलोड करने के लिए
विन्यास फाइल:

```py
>>> from huggingface_hub import hf_hub_download
>>> hf_hub_download(repo_id="google/pegasus-xsum", filename="config.json")
```

फ़ाइल का एक विशिष्ट संस्करण डाउनलोड करने के लिए, निर्दिष्ट करने के लिए `revision` पैरामीटर का उपयोग करें
शाखा का नाम, टैग, या कमिट हैश। यदि आप कमिट हैश का उपयोग करना चुनते हैं, तो यह अवश्य होना चाहिए
छोटे 7-वर्ण कमिट हैश के बजाय पूर्ण-लंबाई हैश:

```py
>>> from huggingface_hub import hf_hub_download
>>> hf_hub_download(
...     repo_id="google/pegasus-xsum",
...     filename="config.json",
...     revision="4d33b01d79672f27f001f6abade33f22d993b151"
... )
```

अधिक विवरण और विकल्पों के लिए, [`hf_hub_download`] के लिए एपीआई संदर्भ देखें।

## Login

कई मामलों में, आपको बातचीत करने के लिए हगिंग फेस खाते से लॉग इन करना होगा
हब: निजी रिपो डाउनलोड करें, फ़ाइलें अपलोड करें, पीआर बनाएं,...
[एक खाता बनाएं](https://huggingface.co/join) यदि आपके पास पहले से कोई खाता नहीं है, और फिर साइन इन करें
अपना [User Access Token](https://huggingface.co/docs/hub/security-tokens) प्राप्त करने के लिए
आपका [सेटिंग्स पेज](https://huggingface.co/settings/tokens)। यूजर एक्सेस टोकन है
हब को आपकी पहचान प्रमाणित करने के लिए उपयोग किया जाता है।

एक बार जब आपके पास अपना उपयोगकर्ता एक्सेस टोकन हो, तो अपने टर्मिनल में निम्नलिखित कमांड चलाएँ:

```bash
huggingface-cli login
# or using an environment variable
huggingface-cli login --token $HUGGINGFACE_TOKEN
```

वैकल्पिक रूप से, आप किसी नोटबुक या स्क्रिप्ट में [`लॉगिन`] का उपयोग करके प्रोग्रामेटिक रूप से लॉगिन कर सकते हैं:

```py
>>> from huggingface_hub import login
>>> login()
```

सीधे अपना टोकन दर्ज करने के लिए कहे बिना प्रोग्रामेटिक रूप से लॉगिन करना भी संभव है
टोकन को [`लॉगिन`] जैसे `लॉगिन(टोकन='hf_xxx'') पास करना। अगर आप भी ऐसा करते हैं तो सावधान हो जाएं
अपना स्रोत कोड साझा करना. इसके बजाय टोकन को सुरक्षित वॉल्ट से लोड करना सबसे अच्छा अभ्यास है
इसे अपने कोडबेस/नोटबुक में स्पष्ट रूप से सहेजने का।

आप एक समय में केवल 1 खाते में ही लॉग इन हो सकते हैं। यदि आप अपनी मशीन को किसी नए खाते में लॉगिन करते हैं, तो आप लॉग आउट हो जाएंगे
पिछले से. `huggingface-cli whoami` कमांड के साथ हमेशा सुनिश्चित करें कि आप किस खाते का उपयोग कर रहे हैं।
यदि आप एक ही स्क्रिप्ट में कई खातों को संभालना चाहते हैं, तो आप प्रत्येक विधि को कॉल करते समय अपना टोकन प्रदान कर सकते हैं। यह
यदि आप अपनी मशीन पर कोई टोकन संग्रहीत नहीं करना चाहते हैं तो यह भी उपयोगी है।

<Tip warning={true}>

एक बार जब आप लॉग इन हो जाते हैं, तो हब के सभी अनुरोध - यहां तक ​​कि वे विधियां जिनके लिए प्रमाणीकरण की आवश्यकता नहीं होती है - आपका उपयोग करेंगे
डिफ़ॉल्ट रूप से एक्सेस टोकन। यदि आप अपने टोकन के अंतर्निहित उपयोग को अक्षम करना चाहते हैं, तो आपको सेट करना चाहिए
`HF_HUB_DISABLE_IMPLICIT_TOKEN` पर्यावरण चर।

</Tip>

## एक कोष बनाये

एक बार जब आप पंजीकृत और लॉग इन हो जाएं, तो [`create_repo`] के साथ एक रिपॉजिटरी बनाएं
समारोह:

```py
>>> from huggingface_hub import HfApi
>>> api = HfApi()
>>> api.create_repo(repo_id="super-cool-model")
```

आपके कोष को निजी बनाएं

```py
>>> from huggingface_hub import HfApi
>>> api = HfApi()
>>> api.create_repo(repo_id="super-cool-model", private=True)
```

निजी भंडार आपके अलावा किसी को दिखाई नहीं देंगे।

<Tip>

रिपोजिटरी बनाने या सामग्री को हब पर भेजने के लिए, आपको उपयोगकर्ता पहुंच प्रदान करनी होगी
टोकन जिसमें `लिखने` की अनुमति है। बनाते समय आप अनुमति चुन सकते हैं
आपके [सेटिंग्स पेज](https://huggingface.co/settings/tokens) में टोकन।

</Tip>

## फाइलें अपलोड करें

अपनी नव निर्मित रिपॉजिटरी में फ़ाइल जोड़ने के लिए [`upload_file`] फ़ंक्शन का उपयोग करें। आप
निर्दिष्ट करने की आवश्यकता है:

1. अपलोड करने के लिए फ़ाइल का पथ.
2. रिपोजिटरी में फ़ाइल का पथ.
3. जहां आप फ़ाइल जोड़ना चाहते हैं उसकी रिपॉजिटरी आईडी।

```py
>>> from huggingface_hub import HfApi
>>> api = HfApi()
>>> api.upload_file(
...     path_or_fileobj="/home/lysandre/dummy-test/README.md",
...     path_in_repo="README.md",
...     repo_id="lysandre/test-model",
... )
```

एक समय में एक से अधिक फ़ाइल अपलोड करने के लिए, [अपलोड](./guides/upload) मार्गदर्शिका पर एक नज़र डालें
जो आपको फ़ाइलें अपलोड करने के कई तरीकों से परिचित कराएगा (git के साथ या उसके बिना)।

## अगले कदम

`हगिंगफेस_हब` लाइब्रेरी उपयोगकर्ताओं को हब के साथ बातचीत करने का एक आसान तरीका प्रदान करती है
पायथन के साथ. इस बारे में अधिक जानने के लिए कि आप अपनी फ़ाइलों और रिपॉजिटरी को कैसे प्रबंधित कर सकते हैं
हब, हम निम्नलिखित के लिए हमारी [कैसे करें मार्गदर्शिकाएं](./guides/अवलोकन) पढ़ने की सलाह देते हैं:

- [अपना भंडार प्रबंधित करें](./guides/repository)।
- हब से [डाउनलोड](./guides/download) फ़ाइलें।
- हब पर [अपलोड](./guides/upload) फ़ाइलें।
- अपने इच्छित मॉडल या डेटासेट के लिए [हब खोजें](./guides/search)।
- तेज अनुमान के लिए [अनुमान एपीआई तक पहुंचें](./guides/अनुमान)।
